/**
 * highlighter provides an easy alternative implementation for frontend store
 * you can also implement your own lib (e.g. indexedDB)
 * or even use a backend store server
 */
import HighlightSource from '../../model/source/index';
import { Store, StoreType } from './types';
declare type StoreInfo = {
    hs: HighlightSource;
    info?: any;
};
declare class LocalStore implements Store<StoreInfo> {
    type: StoreType;
    key: string;
    constructor(id?: any);
    storeToJson(): StoreInfo[];
    jsonToStore(stores: StoreInfo[]): void;
    save(data: StoreInfo | StoreInfo[]): Promise<boolean>;
    forceSave(store: StoreInfo): Promise<boolean>;
    get(id: string): Promise<StoreInfo>;
    remove(id: string): Promise<boolean>;
    getAll(): Promise<StoreInfo[]>;
    removeAll(): Promise<boolean>;
}
export default LocalStore;
