import '@src/util/dataset.polyfill';
import EventEmitter from '@src/util/event.emitter';
import { EventType, HighlighterOptions, DomMeta, HookMap } from './types';
import HighlightSource from '@src/model/source';
import Cache from '@src/data/cache';
import Painter from '@src/painter';
import Store from '@src/addons/store/local.store';
export default class Highlighter extends EventEmitter {
    static event: typeof EventType;
    static LocalStore: typeof Store;
    private _hoverId;
    options: HighlighterOptions;
    hooks: HookMap;
    painter: Painter;
    cache: Cache;
    constructor(options: HighlighterOptions);
    private _getHooks;
    private _highlighFromHRange;
    private _highlighFromHSource;
    private _handleSelection;
    private _handleHighlightHover;
    private _handleHighlightClick;
    run: () => void;
    stop: () => void;
    getDoms: (id?: string) => HTMLElement[];
    addClass: (className: string, id?: string) => void;
    removeClass: (className: string, id?: string) => void;
    getIdByDom: ($node: HTMLElement) => string;
    dispose: () => void;
    setOption: (options: HighlighterOptions) => void;
    fromRange: (range: Range) => HighlightSource;
    fromStore: (start: DomMeta, end: DomMeta, text: any, id: any) => HighlightSource;
    remove(id: string): void;
    removeAll(): void;
}
