/**
 * the HighlightRange Class（HRange）
 * It's a special object called HRange in Highlighter,
 * represents for a piece of chosen dom
 */
import HighlightSource from '../source/index';
import { DomNode, HookMap } from '@src/types';
import Hook from '@src/util/hook';
declare class HighlightRange {
    start: DomNode;
    end: DomNode;
    text: string;
    id: string;
    frozen: boolean;
    static removeDomRange: () => void;
    static fromSelection(idHook: Hook): HighlightRange;
    constructor(start: DomNode, end: DomNode, text: string, id: string, frozen?: boolean);
    serialize($root: HTMLElement | Document, hooks: HookMap): HighlightSource;
}
export default HighlightRange;
