/**
 * Painter object is designed for some painting work about higlighting,
 * including rendering, cleaning...
 * No need to instantiate repeatly. A Highlighter instance will bind a Painter instance.
 */
import HighlightSource from '@src/model/source';
import HighlightRange from '@src/model/range';
import { PainterOptions, HookMap } from '@src/types';
export default class Painter {
    options: PainterOptions;
    $style: HTMLStyleElement;
    styleId: string;
    hooks: HookMap;
    constructor(options: PainterOptions, hooks: HookMap);
    highlightRange(range: HighlightRange): Array<HTMLElement>;
    highlightSource(sources: HighlightSource | HighlightSource[]): Array<HighlightSource>;
    removeHighlight(id: string): void;
    removeAllHighlight(): void;
}
